function out = read(dev, numbytes, precision)
  ARDUINO_I2C_READ = 23;
  if nargin < 2 || nargin > 3
    print_usage ();
  endif
  if ~isnumeric(numbytes)
    error("expected numbytes to be a number");
  endif

  if nargin == 3
    if  !ischar(precision)
      error("expected presision to be s atring");
    endif
    presison = tolower(precision);
    if !strcmp(precision, "uint8") && !strcmp(precision, "int8") && !strcmp(precision, "uint16") && !strcmp(precision, "int16")
      error("expected pression to be (u)int8 or (u)int16 string");
    endif
  else
    precision = 'uint8';
  endif

  % read request
  [tmp, sz] = sendCommand(dev.arduinoobj, "", ARDUINO_I2C_READ, [dev.address numbytes]);
  # skip address and return the data
  out = tmp(2:end);

endfunction
